Encoding: UTF-8
Package: NPHazardRate
Type: Package
Title: Nonparametric Hazard Rate Estimation
Version: 0.1
URL:
Date: 2018-10-13
Authors@R: c(person("Dimitrios", "Bagkavos", role = c("aut", "cre"), email = "dimitrios.bagkavos@gmail.com") )
Author: Dimitrios Bagkavos [aut, cre]
Maintainer: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
Depends: R (>= 3.5.0)
Imports: stats, survival
Description: Provides functions and examples for histogram, kernel (classical, variable bandwidth and transformations based), discrete and semiparametric hazard rate estimators.
License: GPL (>= 2)
NeedsCompilation: no
RoxygenNote: 6.1.0
Packaged: 2018-10-28 21:38:17 UTC; dimitris
Repository: CRAN
Date/Publication: 2018-11-02 18:10:18 UTC
Built: R 4.6.0; ; 2026-04-26 04:22:27 UTC; unix

Encoding: UTF-8
Package: NPHazardRate
Type: Package
Title: Nonparametric Hazard Rate Estimation
Version: 0.3
URL:
Date: 2026-07-22
Authors@R: c(person("Dimitrios", "Bagkavos", role = c("aut", "cre"), email = "dimitrios.bagkavos@gmail.com") )
Author: Dimitrios Bagkavos [aut, cre]
Maintainer: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
Depends: R (>= 3.5.0)
Imports: stats, survival
Description: Provides functions and examples for histogram, kernel (classical, variable bandwidth and transformations based, see e.g. Bagkavos (2008), <doi:10.1080/10485250802440184>, discrete and semiparametric hazard rate estimators.
License: GPL (>= 2)
NeedsCompilation: no
Config/roxygen2/version: 8.0.0
Packaged: 2026-07-22 11:24:11 UTC; Dimitrios Bagkavos
Repository: CRAN
Date/Publication: 2026-07-22 13:00:17 UTC

#useDynLib(Compositional, .registration = TRUE)

importFrom("stats", sd, quantile, rweibull, rlnorm, rchisq, rexp, dweibull, dlnorm, dchisq, dexp,
                    pweibull, plnorm, pchisq, pexp, rbinom, rgeom,
                    rpois, rnbinom,  dbinom, dgeom, dpois, dnbinom,
                    pbinom, pgeom, ppois, pnbinom, dnorm, dunif, pnorm, punif, runif, bw.nrd,
                    integrate)

importFrom("utils", head, tail )

importFrom("survival", survreg, Surv )


exportPattern("^[[:alpha:]]+")

exportPattern("^[^\\.]")

RdistSwitch<-function(dist, SampleSize, par1, par2=.5)
{
  switch(dist,
         weibull = rweibull(SampleSize, par1, par2),
         lognorm = rlnorm(SampleSize),
         chisquare = rchisq(SampleSize, par1),
         exponential = rexp(SampleSize, par1),
         binomial = rbinom(SampleSize, par1, par2),
         geometric = rgeom(SampleSize, par1),
         poisson = rpois(SampleSize, par1),
         negativebinomial = rnbinom(SampleSize, par1, par2),
         uniform = runif(SampleSize, par1, par2)
         )
}

PdfSwitch<-function(xout, dist, par1, par2=.5)
{
  switch(dist,
         weibull = dweibull(xout, par1, par2),
         lognorm = dlnorm(xout, par1, par2),
         chisquare = dchisq(xout, par1),
         exponential = dexp(xout, par1),
         binomial = dbinom(xout, par1, par2),
         geometric = dgeom(xout, par1),
         poisson = dpois(xout, par1),
         negativebinomial = dnbinom(xout, par1, par2),
         uniform = dunif(xout, par1, par2)
         	)
}

CdfSwitch<-function(xout, dist, par1, par2=.5)
{
  switch(dist,
         weibull = 1 - pweibull(xout, par1, par2),
         lognorm = 1 - plnorm(xout, par1, par2),
         chisquare = 1 - pchisq(xout, par1),
         exponential = 1 - pexp(xout, par1),
         binomial = 1 -pbinom(xout, par1, par2),
         geometric = 1 - pgeom(xout, par1),
         poisson = 1 - ppois(xout, par1),
         negativebinomial = 1 - pnbinom(xout, par1, par2),
         uniform = 1 - punif(xout, par1, par2)
      )
}

HazardRate<-function(xout, dist, par1, par2)
{
  switch(dist,
         weibull=dweibull(xout, par1, par2)/(1-pweibull(xout, par1, par2)),
         lognorm = dlnorm(xout)/(1-plnorm(xout)),
         chisquare = dchisq(xout, par1)/(1-pchisq(xout, par1)),
         exponential = dexp(xout, par1)/(1-pexp(xout, par1)),
         normixt = ((2/3) * dnorm(xout,3,1)+(1/3) *dnorm(xout,2,.2))/ (1-((2/3) * pnorm(xout,3,1)+(1/3)*pnorm(xout,2,.2))),
         binomial=dbinom(xout, par1, par2)/(1-pbinom(xout-1, par1, par2)),
         geometric = dgeom(xout, par1)/(1-pgeom(xout-1, par1)),
         poisson = dpois(xout, par1)/(1-ppois(xout-1, par1)),
         negativebinomial = dnbinom(xout, par1, par2)/(1-pnbinom(xout-1, par1, par2))
  )
}

"sn.0"<-function(xin, xout, h, kfun) { sapply(1:length(xout), function(i, xin, xout, h, kfun) sum(kfun((xin-xout[i])/h)), xin, xout, h, kfun) }

"sn.1"<-function(xin, xout, h, kfun) { sapply(1:length(xout), function(i, xin, xout, h, kfun)  sum(kfun((xin-xout[i])/h)*(xin-xout[i])), xin, xout, h, kfun) }

"sn.2"<-function(xin, xout, h, kfun) { sapply(1:length(xout), function(i, xin, xout, h, kfun) sum(kfun((xin-xout[i])/h)*((xin-xout[i])^2)), xin, xout, h, kfun) }

"sn.3"<-function(xin, xout, h, kfun){sapply(1:length(xout), function(i, xin, xout, h, kfun)  sum(kfun((xin-xout[i])/h)*((xin-xout[i])^3)), xin, xout, h, kfun) }

"sn.4"<-function(xin, xout, h, kfun) {sapply(1:length(xout), function(i, xin, xout, h, kfun)  sum(kfun((xin-xout[i])/h)*((xin-xout[i])^4)), xin, xout, h, kfun) }

"sn.5"<-function(xin, xout, h, kfun){sapply(1:length(xout), function(i, xin, xout, h, kfun)  sum(kfun((xin-xout[i])/h)*((xin-xout[i])^5)), xin, xout, h, kfun) }

"sn.6"<-function(xin, xout, h, kfun) {sapply(1:length(xout), function(i, xin, xout, h, kfun)  sum(kfun((xin-xout[i])/h)*((xin-xout[i])^6)), xin, xout, h, kfun) }


"tn.0"<-function(xin, xout, h, kfun, Y) { sapply(1:length(xout), function(i, xin, xout, h, kfun,Y)  sum(kfun((xin-xout[i])/h)*Y), xin, xout, h, kfun, Y) }

"tn.1"<-function(xin, xout, h, kfun, Y){sapply(1:length(xout), function(i, xin, xout, h, kfun,Y)  sum(kfun((xin-xout[i])/h)*((xin-xout[i])*Y)),xin, xout, h, kfun, Y) }

"tn.2"<-function(xin, xout, h, kfun, Y){sapply(1:length(xout), function(i, xin, xout, h, kfun,Y) sum(kfun((xin-xout[i])/h)*((xin - xout[i])^2 )*Y),xin, xout, h, kfun, Y) }

"tn.3"<-function(xin, xout, h, kfun, Y){sapply(1:length(xout), function(i, xin, xout, h, kfun,Y) sum(kfun((xin-xout[i])/h)*((xin - xout[i])^3 )*Y),xin, xout, h, kfun, Y) }





"LocLinEst"<-function(BinCenters, xout, h, kfun, ci)
{
	B1<- sn.2(BinCenters, xout, h, kfun)*tn.0(BinCenters, xout, h, kfun,ci) - sn.1(BinCenters, xout, h, kfun)*tn.1(BinCenters, xout, h, kfun,ci)
	B2<- sn.2(BinCenters, xout, h, kfun)*sn.0(BinCenters, xout, h, kfun) - sn.1(BinCenters, xout, h, kfun)*sn.1(BinCenters, xout, h, kfun)
	llest1<- B1/B2
	llest1
}

"SimpsonInt"<- function(xin, h)
{   #xin = data, h=distance of the points at which function is evaluated
  n<-length(xin)
  nn<-1:n
  int0<-xin[1]
  int2n<-xin[n]
  inteven<-xin[seq(3,n-1,by=2)]
  intodd<-xin[seq(2,n-2,by=2)]
  sumodd<-sum(intodd)
  sumeven<-sum(inteven)
  res<-(h/3)*(int0+4*sumodd+2*sumeven+int2n)
  res
}

"DiscretizeData"<-function(xin, xout)
{
  MinX<- min(xin)
  MaxX<- max(xin)-0.2*max(xin)
  N<-length(xin)
  n<-length(xout)
  Delta<-(MaxX-MinX)/n
  PartInt<-c(MinX, MinX+(1:n)*Delta) #Partion the interval (x[1], x[n]) into subintervals
  FirstBinCenter<-(PartInt[1]+PartInt[2])/2
  BinCenters<- c(FirstBinCenter, FirstBinCenter+(1:(n-1))*Delta)
  fi<-sapply(1:n, function(i, xin, PartInt) length(which(xin > PartInt[i] & xin <= PartInt[i+1])), xin, PartInt) #crete the bin counts
  citmp<-fi/(N-cumsum(fi)+1)
  ci<-citmp/Delta
  list(BinCenters=BinCenters, ci=ci, Delta=Delta)
}

"SDHazardRateEst"<- function(xin, xout, h, ci)
  {
    n<- length(xin)
    n1<-1:n
    xin.use<-sort(xin)
    arg1<-(sapply(xout, "-", xin.use))/h
    arg2<-SDBiweight(arg1)* ci/(n-n1+1)
    arg3<-colSums(arg2)/h^3
    arg3
  }

"KMest"<-function(xin, cens, xout)
  #this is the actual KM estimate not the version that estimates the censoring distribution
{
  ordxin <- sort(xin) #order input data=Xi
  ordcens <- cens[order(xin)] #order censoring =Di
  n <- length(xin)
  nn <- length(xout)
  vKuse <- sapply(1:nn, function (i, ordxin, xout)
  {
    k.use<-c(max(which(ordxin <= xout[i])), min(which(xout[i] <= ordxin)))
    k.use.1<-ifelse(is.infinite(k.use[2]), c(k.use[1],k.use[1]) , k.use) #cat("k.use = ", k.use, "\n")
    l.use<- max(k.use.1)
    l.use
  }, ordxin, xout)
  vK <- vKuse -1

  Huse<-sapply(vK, function (i,n,ordcens) {
    i<-ifelse(i==-Inf, 0,i)
    index<-1:i
    expon.use<-ordcens[index]
    ((n-index+1)/(n-index+2))^expon.use
  }
  , n, ordcens)
  result<-sapply(Huse, prod)
  result
}

lambdahat<-function(xin, cens, xout)
  #non smooth estimate of the discrete hazard function
{
  n<-length(xout)
  mat<-sapply(1:n, function(i, xout, xin, cens)
  {
    xoutuse<-xout[i]
    whichtk<-which(xoutuse == xin) ## index of those T_j = t_k
    xinuse<-xin[whichtk]
    deltause<-cens[whichtk]
    num<- length(which(deltause !=	0))	#equivalent to \sum_{i=1}^n I(T_i = t_k)\Delta_i
    den<-length(xinuse)
    c(num, den)
  }, xout, xin, cens)
  mat<-matrix(mat, ncol=2, byrow=TRUE)

  numerator<-mat[,1]
  denuse<-mat[,2]
  m <- length(denuse)
  denominator<-sapply(1:m,  function(j, denuse, m) sum(denuse[j:m]), denuse=denuse, m=m) #denominator: \sum_{j \geq k} \sum_{k=1}^n I(T_j=t_k)
  numerator/(denominator+1)
}


nsf<-function(xin, cens, xout)
{
  n<-length(xout)
  mat<-sapply(1:n, function(i, xout, xin, cens)
  {
    xoutuse<-xout[i]
    whichtk<-which(xoutuse == xin) ## index of those T_j = t_k
    length(xin[whichtk]	)
  }, xout, xin, cens)
  #mat<-matrix(mat, ncol=2, byrow=T)
  m <- length(mat)
  denominator<-sapply(1:n,  function(j, mat, n) sum(mat[j:n]), mat=mat, n=n)
  denominator
}



"Habbema"<-function(xin, x)
{
  n<-length(x)
  nsuse<-nsf(xin, xin, x)
  #cat(nsuse)
  huse<- .8 * 0.08 * (nsuse/length(xin))^1.5
  #cat(huse)
  mat<-sapply(1:n, function(i, x, xin, huse)
  {
    xoutuse<-x[i]
    hh<-huse[i]
    (1-hh)^((xoutuse-xin)^2)
  }, x, xin, huse)
  mat
}

"TutzPritscher"<-function(xin, cens, xout)
{
  mle<-lambdahat(xin, cens, xout)
  nsuse<-nsf(xin, cens, xin)
  #nsuse<-matrix(nsuse, nrow=length(xin), ncol=length(xout))
  huse<-bw.nrd(xin)
  kernel<-Habbema(xin, xout)
  weightsuse<- nsuse * kernel
  weights<-weightsuse/colSums(weightsuse)
  colSums(mle * weights, na.rm=TRUE)
}

Tm<-function(tk, xout, distribution, par1, par2)
  # This is used to calculate max(t_k; 1-\sum_{l=0}^k \eta_l > \epsilon), \epseilon>0
{
  SumDistrTk<-PdfSwitch(xout, distribution, par1, par2)
  n<-length(SumDistrTk)
  SumTK<-sapply(1:n,  function(i, SumDistrTk, n) sum(SumDistrTk[i:n]), SumDistrTk=SumDistrTk, n=n) #\sum_{l=0}^n \eta_l
  Tmh<- 1-SumTK  #1-\sum_{l=0}^n \eta_l

  maxTmh<-max(which(Tmh == max(Tmh)) )#Tmh[Tmh>= 0 & Tmh<= min(Tmh[Tmh>=0])] # max{1-\sum_{l=0}^n \eta_l >0}
  tk[maxTmh] # find the gridpoint tk which corresponds to Tmh, return the result.
}



CparamCalculation<-function(gamparam, VehHazard)
  # returns the C smoothing parameter calculated as
  # C= gamma/max_{k \geq 0} ( \lambda(t_{k-1}) + \lambda(t_k) + \lambda(t_{k+1}) )
{
  VehHazard<-c(0, VehHazard) # \lambda(t_{-1}) is set to 0 here
  n<-length(VehHazard)-2
  Lsums<-sapply(1:n, function(i, VehHazard) sum(VehHazard[seq(i,i+2, by=1)]), VehHazard) #calculate \lambda(t_{k-1}) + \lambda(t_k) + \lambda(t_{k+1})

  gamparam/max(Lsums) #return C
}

##################################################################################################################
##############alternative DetermineSCprod<-function(NonParEst, VehHazard, Hvector, n, gammapar) function #########

# DetermineSCprod<-function(NonParEst, VehHazard, Hvector, n, gammapar)
#   #this finds SC = \gamma((n+1) \hat B_1)^{-1} \hat V_1
#   # n = number of obs, gammapar = sum of vehicle haz at xout (computed elsewhere)
# {
#   VehHazard<-c(0, VehHazard)
#   NonParEst<-c(0, NonParEst)
#   n<-length(VehHazard)-2
#   B1hatElements<-sapply(1:n, function(i, VehHazard, NonParEst)
#     ((NonParEst[i] + NonParEst[i+2])* VehHazard[i+1] - (VehHazard[i] + VehHazard[i+2])* NonParEst[i+1] )^2
#     , VehHazard, NonParEst) #calculate (\hat \lambda(t_{k-1}) + \hat \lambda(t_{k+1})) \lambda(t_k) - ...)^2
#
#   B1hat<-sum(B1hatElements)
#
#   V1hatElements<-sapply(1:n, function(i, VehHazard, NonParEst)
#     NonParEst[i+1]*(1-NonParEst[i+1]) *(VehHazard[i] + VehHazard[i+2])/Hvector[i]
#     , VehHazard, NonParEst)
#
#   V1hat<- sum(V1hatElements	)
#   gammapar *  V1hat / ((n+1)*B1hat)	#estimated optimal product for S and C
#
# }

#######################################################################################################################

# DetermineSCprod<-function(NonParEst, VehHazard, Hvector, nn, gammapar)
#   #this finds SC = \gamma((n+1) \hat B_1)^{-1} \hat V_1
#   # n = number of obs, gammapar = sum of vehicle haz at xout (computed elsewhere)
# {
#   VehHazard<-c(0, VehHazard)
#   NonParEst<-c(0, NonParEst)
#   n<-length(VehHazard)-2
#   B1hatElements<-sapply(1:n, function(i, VehHazard, NonParEst)
#     ( sum(NonParEst[seq(i,i+2, by=2)])* VehHazard[(i+i+2)/2] - sum(VehHazard[seq(i,i+2, by=2)])* NonParEst[(i+i+2)/2])^2
#     , VehHazard, NonParEst) #calculate (\hat \lambda(t_{k-1}) + \hat \lambda(t_{k+1})) \lambda(t_k) - ...)^2
#
#   B1hat<-sum(B1hatElements)
#   V1hatElements<-sapply(1:n, function(i, VehHazard, NonParEst, Hvector){
#     NonParEst[(i+i+2)/2]*(1-NonParEst[(i+i+2)/2]) *sum(VehHazard[seq(i,i+2, by=2)])/Hvector[i]}
#     , VehHazard, NonParEst, Hvector)
#   V1hat<- sum(V1hatElements)
#   (gammapar *  V1hat) / ((nn+1)*B1hat)	#estimated optimal product for S and C
# }

power.matrix <- function(M, n){
  #Raise matrix M to the n'th power
  powers <- base(n, 2)
  result <- diag( nrow(M) )
  for(i in 1:length(powers)) {
    if(powers[i])
      result <- result %*% M
    M <- M %*% M
  }
  result
}

base <- function(m, b){
  #Express m as powers of b; m may be vector
  maxi <- floor(log(max(m))/log(b))
  result <- matrix( 0, length(m), maxi+1 )
  for(i in 1:(maxi+1)) {
    result[,i] <- m %% b
    m <- m %/% b
  }
  result
}


SmoothedEstimate<-function(NonParEst, VehHazard, gammapar, SCproduct, Cpar)
{
  n<-length(VehHazard)-2 # maybe length(VehHazard)-2
  Sparam<- floor(SCproduct/Cpar) # S = S*C/C - this may need to change
  b0<- gammapar - Cpar*VehHazard[2] # b0 = \gamma - C \lambda_1 (counting starts at zero in the manuscript)
  bkplus1<- gammapar - Cpar * head(tail(VehHazard,2),1) # thisis the last value of the Bk vector (not specified in manuscript)
  ak <- Cpar * VehHazard
  bk <- sapply(1:n, function(i, VehHazard, Cpar, gammapar)
  { gammapar - Cpar * (VehHazard[i] + VehHazard[i+2])}, VehHazard, Cpar, gammapar)
  bk<- c(b0,bk, bkplus1)
  Wmatrix<-diag(bk)

  Wmatrix[col(Wmatrix) - row(Wmatrix)==1]<-head(ak, length(ak)-1)
  Wmatrix[ row(Wmatrix) - col(Wmatrix) ==1]<- tail(ak, length(ak)-1)
  LambdaMat<- (1/gammapar) * ( diag(1, nrow = length(VehHazard), ncol = length(VehHazard)) %*% Wmatrix)

  #################### test #################################
  #cat("\n Vehicle Hazard = ", VehHazard, "\n LAMBDA MAT = ", NonParEst %*% power.matrix(LambdaMat,200), "\ndiag= ", diag(power.matrix(LambdaMat,200)),  "\n")
  #aaaa<- NonParEst %*% power.matrix(LambdaMat,5)
  #plot(1:length(aaaa), VehHazard, type="l")
  #lines(1:length(aaaa), aaaa, lty=4)
  ###########################################################

  if(Sparam == 0) LambdaMatrixSpower <- diag(1, nrow=length(VehHazard), ncol= length(VehHazard))
  else LambdaMatrixSpower <- power.matrix(LambdaMat, Sparam)

  SmoothEst<- matrix(NonParEst, nrow=1, ncol=length(VehHazard)) %*% LambdaMatrixSpower
  SmoothEst

}

# VehicleHazardRate<-function(xout, vehicledistr, param1, param2)
# {
#   switch(vehicledistr, binomial=dbinom(xout, param1, param2)/(1-pbinom(xout-1, param1, param2))
#          , geometric = dgeom(xout, param1)/(1-pgeom(xout-1, param1))
#          , poisson = dpois(xout, param1)/(1-ppois(xout-1, param1))
#          , negativebinomial = dnbinom(xout, param1, param2)/(1-pnbinom(xout-1, param1, param2))
#
#   )
# }






SemiparamEst<-function(xin, cens, xout, Xdistr, Udistr, vehicledistr, Xpar1=1, Xpar2=0.5, Upar1=1, Upar2=0.5, vdparam1=1, vdparam2=0.5)
{


  TkCutOff<-min(Tm(xout, xout, Xdistr, Xpar1, Xpar2) , Tm(xout, xout, Udistr, Upar1, Upar2), Tm(xout, xout, vehicledistr, vdparam1, vdparam2))
  # cat(xout, " ", TkCutOff)
  xout<-head(xout, TkCutOff)

  result<-matrix(nrow=length(xout), ncol=2)

  Qvector <- 1-cumsum(PdfSwitch(xout-1, Xdistr, Xpar1, Xpar2))
  Pvector <- 1-cumsum(PdfSwitch(xout-1, Udistr, Upar1, Upar2))

  Hvector <-  Pvector * Qvector
  NonparamEst<-lambdahat(xin, cens, xout)

  VehicleHazard<-HazardRate(xout, vehicledistr, vdparam1, vdparam2)
  GammaParam <- 2 #sum(VehicleHazard)
  Cpar <-  0.5# CparamCalculation(GammaParam , VehicleHazard) #upper bound for C 0.5#
  SCproduct<- 32* Cpar # DetermineSCprod(NonparamEst, VehicleHazard, Hvector , length(xin), GammaParam)

  SmoothEst<- SmoothedEstimate(NonparamEst, VehicleHazard, GammaParam , SCproduct, Cpar )
  result[,1]<-xout
  result[,2]<-SmoothEst
  result
}

"HazardHistogram"<- function(xin, xout, cens, bin)
{
  MinX<-0.1#min(xin)
  MaxX<- 3#max(xin)#max(xin)
  N<-length(xin)
  nn<-length(xout)
  #n<-length(xout)
  #Delta<-(MaxX-MinX)/n
  #cat(Delta)
  n<-(MaxX - MinX)/bin
  PartInt<-c(MinX, MinX+(1:n)*bin) #Partion the interval (x[1], x[n]) into subintervals
  iRows = length(PartInt)
  MatOut<-matrix(ncol=2, nrow=iRows )
  MatOut[,1]<-PartInt
  ordxin<-sort(xin)
  ordcens<-cens[order(xin)]
  indexequals1<-which(ordcens == 1)
  xinnocens<- xin[indexequals1] # X_i for which \delta_i=1
  fizero<-sapply(1:iRows , function(i, xinnocens, PartInt) length(which(xinnocens >= PartInt[i] & xinnocens < PartInt[i+1])),xinnocens, PartInt) #crete the bin counts
  fi<-sapply(1:iRows , function(i, xin, PartInt) length(which(xin >= PartInt[i] & xin < PartInt[i+1])),xin, PartInt)
  MatOut[,2]<-fizero/(bin*cumsum(fi)+1)
  MatOut
}

"DefVarBandRule"<-function(xin, cens)
{
  m4K<-0.0857 # for Epanechnikov kernel
  RofK<- 3/5
  n<-length(xin)
  par<- survreg(Surv(xin, cens) ~1, dist="weibull")
  pl<- 1/par$scale
  pp<- exp(par$coefficients)
  uplim<- max(rweibull(1000, shape=pp, scale=pl))
  Rg<- integrate(gx, lower=0.04, upper = uplim, p=pp, l=pl)$value
  xuse<-seq(0.04, uplim, length=100)
  hatmint<-  lwF(xuse, pp, pl)
  #cat(hatmint, "\n")
  hatM<-  integrate(lwF, lower=0.04, upper = uplim, p=pp, l=pl)$value
  ((RofK * hatM)/(8*n* m4K^2 * Rg))^(1/14)
}

"HazardRateEst"<- function(xin, xout, kfun, h, ci)
  {
    n<- length(xin)
    n1<-1:n
    xin.use<-sort(xin)
    arg1<-(sapply(xout, "-", xin.use))/h
    arg2<-kfun(arg1, h)* ci/(n-n1+1)
    arg3<-colSums(arg2)/h
    arg3
  }

VarBandHazEst<-
  #Adaptive variable bandwidth hazard rate estimator
  function(xin, xout,  kfun, h1, h2, ci)
  {
    n<- length(xin)
    nn<-length(xout)
    n1<-1:n
    xin.use<-sort(xin)
    pilot.est<-HazardRateEst(xin.use, xin.use, kfun, h1, ci) #Pilot estimate (W-L)
    sqrt.pilot<-sqrt(pilot.est)
    vhre<-sapply(1:nn, function(i, xin.use, xout, h2, kfun, n, n1,ci, sqrt.pilot)
    {
      sum( (sqrt.pilot *  kfun( ((xout[i]-xin.use)/h2) * sqrt.pilot)	)*ci/(n-n1+1))
    }, xin.use, xout, h2, kfun, n, n1,ci, sqrt.pilot)
    vhre/h2
  }

"cvfunction"<- function(h, xin, xout, cens)
{
  MinX<- 0.01#min(xin)
  MaxX<- 3#max(xin)
  N<-length(xin)
  n<-(MaxX - MinX)/h
  PartInt<-c(MinX, MinX+(1:n)*h) #Partion the interval (x[1], x[n]) into subintervals
  ordxin<-sort(xin)
  ordcens<-cens[order(xin)]
  indexequals1<-which(ordcens == 1)
  xinnocens<- xin[indexequals1] # X_i for which \delta_i=1
  fizero<-sapply(1:n, function(i, xinnocens, PartInt) length(which(xinnocens >= PartInt[i] & xinnocens < PartInt[i+1])),xinnocens, PartInt) #crete the bin counts
  fi<-sapply(1:n, function(i, xin, PartInt) length(which(xin >= PartInt[i] & xin < PartInt[i+1])),xin, PartInt)
  Fi<-cumsum(fi)
  sum( (2*fizero - fizero^2)/(Fi*(Fi+1)) - fizero^2 /(Fi*((Fi+1)^2))) /h
}

"LLHRPlugInBand"<-function(BinCenters, h, kfun, Delta, xin, xout, IntKfun,   ci, cens)
{
  sn0<-sn.0(BinCenters, BinCenters, h, kfun)
  sn1<-sn.1(BinCenters, BinCenters, h, kfun)
  sn2<-sn.2(BinCenters, BinCenters, h, kfun)
  sn3<-sn.3(BinCenters, BinCenters, h, kfun)
  sn4<-sn.4(BinCenters, BinCenters, h, kfun)
  sn5<-sn.5(BinCenters, BinCenters, h, kfun)
  sn6<-sn.6(BinCenters, BinCenters, h, kfun)
  tn0<-tn.0(BinCenters, BinCenters, h, kfun, ci)
  tn1<-tn.1(BinCenters, BinCenters, h, kfun, ci)
  tn2<-tn.2(BinCenters, BinCenters, h, kfun, ci)
  tn3<-tn.3(BinCenters, BinCenters, h, kfun, ci)
  #COMPUTE THE LOCAL LINEAR DERIVATIVE ESTIMATE:

  den<-  sn0*sn2*sn4*sn6 - sn0*sn2*(sn5^2) - sn0*(sn3^2) *sn6 + 2*sn0*sn3*sn4*sn5-sn0*(sn4^3)-sn1^2*sn4*sn6 +( sn1^2)*(sn5^2 )+ 2*sn1*sn2*sn3*sn6
  - 2*sn1*(sn3^2) *sn5 - 2*sn1*sn4*sn2*sn5 + 2*sn1*sn3*(sn4^2) - (sn2^3) *sn6 + 2*(sn2^2)*sn3*sn5 + (sn2^2)*(sn4^2)-3*sn2*sn4*sn3^2 + sn3^4
  A1<-   sn1*sn3*sn6 -sn1*sn4*sn5 - (sn2^2) *sn6+sn2*sn3*sn5+sn2*sn4^2 -sn4*( sn3^2)

  A2<- sn0*sn3*sn6-sn0*sn4*sn5-sn2*sn1*sn6+sn3*sn2*sn4+sn1*sn3*sn5-(sn3^3)
  A3<- sn0*sn2*sn6-sn0*(sn4^2) -(sn1^2) *sn6+2*sn3*sn1*sn4-sn2*sn3^2
  A4<-  sn0*sn2*sn5 - sn0*sn3*sn4 - (sn1^2) *sn5+sn1*sn2*sn4+sn1*(sn3^2)-sn3*(sn2^2)
  est2<- 2* (A1*tn0 - A2*tn1 + A3*tn2 - A4*tn3)/den

  theta22<- Delta * sum(est2^2)
  RofK <- 3* sqrt(5)/25
  MuofK <- 3* sqrt(5)	/35
  Muse<-  NP.M.Estimate(xin, cens, xout) #1/(1-IntKde(xin, max(xout), h, IntKfun)) -1
  N<-length(xin)
  huse1<-( RofK*Muse /(N * MuofK^2 * theta22))^0.2
  huse1
}

"TransHazRateEst"<-
  #Transformed hazard rate estimator (2nd stage) using nonparametric transformation -log(1-\hat F(x))
  function(xin, xout, kfun, ikfun, h1, h2, ci)
  {
    n<-length(xin)
    n1<-1:n
    nn<-length(xout)
    xin.use<-sort(xin)
    GofX<- iHazardRateEst(xin.use, xout, kfun, h1, ci)
    Tsample<- iHazardRateEst(xin.use, xin.use, ikfun, h1, ci)

    GofXdashed<- HazardRateEst(xin.use, xout,  kfun, h1, ci)
    arg1<-(sapply(GofX, "-", Tsample))/h2
    arg2<-kfun(arg1)* ci/(n-n1+1)
    arg3<-colSums(arg2)/h2
    TransEstimate<-  arg3*GofXdashed

    TransEstimate
  }

"PlugInBand"<-function( xin, xout,   cens, kfun )
{
  n<-length(xin)
  RofK <- 5/7 # for biweight - for epanech use 3/5
  MuofK <- 1/7 # for biweight - for epanech use 1/5

  hsd<- bw.nrd(xin) # RefBand.b.Sec.Der(xin, cens, xout) #
  theta<-SDHazardRateEst(xin, xout, hsd, cens)
  theta22<-SimpsonInt(theta^2, xout[2]-xout[1])

  M.funct<-HazardRateEst(xin, xout, kfun, bw.nrd(xin), cens)/KMest(xin, cens, xout)

  Muse<-  SimpsonInt(M.funct, xout[2]-xout[1])
  #cat("Muse PluginBand= ", Muse, " Sec. der =", theta22, "\n")
  huse1<-( RofK*Muse /(n * MuofK^2 * theta22))^0.2
  huse1
}

"iHazardRateEst"<- function(xin, xout, ikfun, h, ci)
{
  n<- length(xin)
  n1<-1:n
  xin.use<-sort(xin)
  arg1<-(sapply(xout, "-", xin.use))/h
  arg2<-ikfun(arg1)* ci/(n-n1+1)
  arg3<-colSums(arg2)
  arg3
}

\name{RdistSwitch, PdfSwitch, CdfSwitch, HazardRate}
\title{User driven input for random number generation and pdf, survival and hazard rate function calculation}
\alias{RdistSwitch}
\alias{PdfSwitch}
\alias{CdfSwitch}
\alias{HazardRate}

\description{
Auxiliary functions that help automate the process of random number generation or pdf, survival function or hazard rate functions
}


\usage{
RdistSwitch(dist, SampleSize, par1, par2)
PdfSwitch(xout, dist, par1, par2)
CdfSwitch(xout, dist, par1, par2)
HazardRate(xout, dist, par1, par2)
}

\arguments{
\item{dist}{A string. Corresponds to one of weibull, lognorm, chisquare, exponential, binomial, geometric, poisson, negativebinomial, uniform}
\item{SampleSize}{The size of the random sample to be drawn}
\item{xout}{Grid points where the function will be evaluated}
\item{par1}{parameter 1 of the distirbution}
\item{par2}{parameter 2 of the distirbution}
}

\details{Implements random number generation and density, survival and hazard rate estimates for several distributions. These functions are mainly used when simulating the mean square error etc from known distributions.}

\value{
A vector with the values of the function at the designated points xout or the random numbers drawn.
}

%\references{
%Bagkavos, Dimitrios and Patil, Prakash (2009) Variable Bandwidths for Nonparametric Hazard Rate Estimation, Communications in Statistics - %Theory and Methods, 38, 1055-1078, http://dx.doi.org/10.1080/03610920802364088
%}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com> }

%\note{
%%  ~~further notes~~
%}

%\seealso{ \code{\link{HazardRateEst}, \link{TransHazRateEst} } }

\name{LLHRPlugInBand}
\title{Simple Plug in badnwidth selector}
\alias{LLHRPlugInBand}
\description{
Provides  the asymptotic MISE optimal plug-in bandwidth for the local linear hazard rate estimator \code{\link{LocLinEst}}, defined in (4),  \href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011)}. This is the binned data version of the \code{\link{PlugInBand}} AMISE optimal bandwidth rule.
}

\usage{
LLHRPlugInBand(BinCenters, h, kfun, Delta, xin, xout, IntKfun, ci, cens)
}

\arguments{
\item{BinCenters}{ A vector of data points, the centers of the bins resulting from the discretization of the data.}
 \item{h}{ Bandwidth for the estimate of the distribution function. }
 \item{kfun}{ A kernel function. }
 \item{Delta}{A scalar. The length of the bins. }
 \item{xin}{ A vector of data points}
 \item{xout}{ The point at which the estimates should be calculated.}
\item{IntKfun}{ The integrated kernel function.}
\item{ci}{ Crude hazard rate estimates.}
\item{cens}{ Censoring Indicators.}
}

\details{
The bandwidth selector requires binned data, i.e. data in the form \eqn{(x_i, y_i)} where \eqn{x_i} are the bin centers and \eqn{y_i} are empirircal hazard rate estimates at each \eqn{x_i}. This is achieved  via  the \code{\link{DiscretizeData}} function. As it can be seen from (4) in \href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011)}, the bandwidth selector also requires an estimate of the functional
\deqn{
\int \left \{ \lambda^{(2)}(x) \right \}^2 \,dx
}
which is readily implemented in \code{\link{PlugInBand}}. It also requires an estimate of the constant
\deqn{
\int \frac{\lambda(x)}{1-F(x)} \,dx
}
For this reason additionally the  plug in bandwidth rule is also used, as it is implemented in the  \code{\link{bw.nrd}} distribution function default bandwidth rule of \href{https://onlinelibrary.wiley.com/doi/abs/10.1111/j.1467-9469.2005.00472.x}{Swanepoel and Van Graan (2005)}. The constants \eqn{R(K)} and \eqn{\mu_2^2(K)} are deterministic and specific to the kernel used in the implementation hence can be claculated precisely.
}

\value{
A scalar with the value of the suggested bandwidth.
}

\references{
\href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011), Annals of the Institute of Statistical Mathematics, 63(5), 1019-1046.}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}



\seealso{ \code{\link{PlugInBand} } }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated
SampleSize<-100 #amount of data to be generated
ti<- rweibull(SampleSize, .6, 1) # draw a random sample
ui<-rexp(SampleSize, .2)         # censoring sample
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)                  # observed data
cen<-rep.int(1, SampleSize)      # initialize censoring indicators
cen[which(ti>ui)]<-0             # 0's correspond to censored indicators

a.use<-DiscretizeData(ti, x)     # discretize the data
BinCenters<-a.use$BinCenters     # get the data centers
ci<-a.use$ci                     # get empircal hazard rate estimates
Delta=a.use$Delta                # Binning range
h2<-bw.nrd(ti)                   # Bandwidth to use in constant est. of the plug in rule
h.use<-h2                        # the first element is the band to use

huse1<- LLHRPlugInBand(BinCenters,h.use,Epanechnikov,Delta,ti,x,IntEpanechnikov,ci,cen)
huse1


}

\name{HazardRateEst}
\title{Kernel Hazard Rate Estimation}
\alias{HazardRateEst}
\description{
Implements the (classical) kernel hazard rate estimator for right censored data defined in \href{https://projecteuclid.org/download/pdf_1/euclid.aos/1176346265}{Tanner and Wong (1983)}.
}

\usage{
HazardRateEst(xin, xout, kfun, h, ci)
}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
 \item{xout}{A vector of grid points at which the estimate will be calculated. }
 \item{kfun}{Kernel function to use. Supported kernels: Epanechnikov, Biweight, Gaussian, Rectangular, Triangular, HigherOrder. }
 \item{h}{A scalar, the bandwidth to use in the estimate. }
 \item{ci}{A vector of censoring indicators: 1's indicate uncensored observations, 0's correspond to censored obs.}
}

\details{
The kernel hazard rate estimator of \href{https://projecteuclid.org/download/pdf_1/euclid.aos/1176346265}{Tanner and Wong (1983)} is given by
\deqn{\hat \lambda(x;h) = \sum_{i=1}^n \frac{K_h(x-X_{(i)})\delta_{(i)}}{n-i+1}}{\lambda(x;h) = sum(K_h(x-X_i)*\delta_i*(n-i+1)^{-1})}
\eqn{h} is determined by  a bandwidth rule such as \code{\link{PlugInBand}}. \code{\link{HazardRateEst}} is also used as a pilot estimate in the implementation of both the variable bandwidth estimate \code{\link{VarBandHazEst}} and the transformed hazard rate estimate  \code{\link{TransHazRateEst}}.
}

\value{
A vector with the hazard rate estimates at the designated points xout.
}

\references{
\href{https://projecteuclid.org/download/pdf_1/euclid.aos/1176346265}{Tanner and Wong (1983), The Estimation Of The Hazard Function From Randomly Censored Data By The Kernel Method, Annals of Statistics,  3, pp. 989-993.}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

\seealso{ \code{\link{VarBandHazEst}, \link{TransHazRateEst}, \link{PlugInBand}} }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated
plot(x, HazardRate(x, "weibull", .6, 1),  type="l", xlab = "x",
                   ylab="Hazard rate") #plot true hazard rate function
SampleSize <- 100
ti<- rweibull(SampleSize, .6, 1)  #draw a random sample from the actual distribution
ui<-rexp(SampleSize, .2)  #draw a random sample from the censoring distribution
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)             #this is the observed sample
cen<-rep.int(1, SampleSize) #censoring indicators
cen[which(ti>ui)]<-0        #censored values correspond to zero
huse<-PlugInBand(x1, x,   cen, Biweight)
arg2<-HazardRateEst(x1, x, Epanechnikov, huse, cen) #Calculate the estimate
lines(x, arg2, lty=2)       #draw the result on the graphics device.
}

\name{HazardHistogram}
\title{Histogram Hazard Rate Estimator}
\alias{HazardHistogram}
\description{
Implements the histogram hazard rate estimator of \href{https://www.jstor.org/stable/42003749}{Patil and Bagkavos (2012)}
}

\usage{
HazardHistogram(xin, xout, cens, bin)
}

\arguments{
\item{xin}{ A vector of data points.  Missing values not allowed.}
\item{xout}{A vector of grid points at which the histogram will be calculated.}
 \item{cens}{ A vector of 1s and zeros, 1's indicate uncensored observations, 0's correspond to censored obs. }
\item{bin}{ Number of bins to use in construction of the histogram.}
}

\details{
The histogram hazard rate estimator is defined in (1), \href{https://www.jstor.org/stable/42003749}{Patil and Bagkavos (2012)} by
\deqn{
\hat \lambda (x) = h_n^{-1} C_{i_{(x)}} = h_n^{-1}f_{i_{(x)}}^0(\bar F_{i_{(x)}}+1)^{-1}.
}}

\value{
A vector with the values of the histogram estimate at each bin.
}

\references{
\href{https://www.jstor.org/stable/42003749}{Patil and Bagkavos (2012), Histogram for hazard rate estimation,  pp. 286-301, Sankhya, B.}

}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\note{
%%  ~~further notes~~
%}

%\seealso{
%\code{\link{alfa.profile}, \link{alfa}, \link{alfainv}, \link{alpha.mle}
%}
%}

\examples{
SampleSize <-400
ti<-rweibull(SampleSize,0.5,0.8)
xout<-seq(0.02, 3.5, length=80)
true.hazard<-dweibull(xout,0.5, 0.8)/(1-pweibull(xout, 0.5, 0.8))
cen<-rep.int(1, SampleSize)
cen[sample(1:SampleSize, SampleSize/10)]<-0

band<-nlminb(start= 2, obj=cvfunction, control = list(iter.max = 100, x.tol = .001)
            ,xin=ti, xout= xout, cens = cen, 	lower=.01, upper=max(xout))
bin<- 3.49 * sd(ti)^2 * SampleSize^(-1/3) /50 #Scott 1979 Biometrika default rule
bin<-unlist(band[1])
histest<- HazardHistogram(ti,xout, cen, bin+0.013 )

plot(xout, true.hazard, type="l")
lines(histest[,1], histest[,2], col=2, type="s")
barplot( histest[,2], rep(bin, times=length(histest[,2])))
lines(xout, true.hazard, type="l", lwd=2, col=2)
}

\name{NP.M.Estimate}
\title{Estimate of bandwidth constant}
\alias{NP.M.Estimate}
\description{
Calculation of the contant term in the AMISE plugin bandwidth rule \code{\link{PlugInBand}}.
}

\usage{NP.M.Estimate(xin, cens, xout) }

\arguments{
 \item{xin}{ A vector of data points}
 \item{xout}{ The point at which the estimates should be calculated.}
\item{cens}{ Censoring Indicators.}
}

\details{
Approximates the term
\deqn{
 M = \int_0^T  \frac{ \lambda_T(x)}{1-F(x)} \,dx
}
 which is needed in the optimal AMISE bandwidth expression of \code{\link{PlugInBand}}. The integrand
\deqn{  \frac{\lambda_T(x)}{1-F(x)}\,dx }
is calculated by \code{\link{HRSurv}} and integration is performed via the extended Simpson's numerical integration rule (\code{\link{SimpsonInt}}).
}

\value{
A scalar with the value of the constant.
}

\references{
\href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos, An $L_1$ analysis of a kernel-based hazard rate estimator, Australian and New Zealand J. Statist., (60), 43-64, (2018).}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}



%\seealso{ \code{\link{HazardRateEst}, \link{LLHRPlugInBand} } }

%\examples{
%x<-seq(0, 5,length=100) #design points where the estimate will be calculated
%SampleSize<-100 #amount of data to be generated
%ti<- rweibull(SampleSize, .6, 1) # draw a random sample
%ui<-rexp(SampleSize, .2)         # censoring sample
%cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
%x1<-pmin(ti,ui)                  # observed data
%cen<-rep.int(1, SampleSize)      # initialize censoring indicators
%cen[which(ti>ui)]<-0             # 0's correspond to censored indicators



%huse1<- PlugInBand(x1, x, cen, Biweight)
%huse1


%}

\name{DefVarBandRule}
\alias{DefVarBandRule}
\title{Default adaptive bandwidth rule}

\description{
Implements an adaptive variable bandwidth hazard rate rule for use with the \code{\link{VarBandHazEst}} based on the Weibull distribution, with parameters estimated by maximum likelihood
}

\usage{DefVarBandRule(xin, cens)}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
 \item{cens}{A vector of censoring indicators: 1's  indicate uncensored observations, 0's correspond to censored obs.}
}

\details{
The adaptive AMISE optimal bandwidth for the variable bandwidth hazard rate estimator \code{\link{VarBandHazEst}} is given by
\deqn{ h_2 =  \left [ \frac{R(K) M_2}{8n\mu_4^2(K) R(g)} \right ]^{1/14}}
 where
 \deqn{ M_2 =   \int \frac{\lambda^{3/2}(x)}{1-F(x)} \,dx}
and
\deqn{ g(x)=\frac{1}{24\lambda(x)^5} \Bigl (24{\lambda'(x)}^4-36{\lambda'(x)}^2{\lambda''(x)}^2\lambda(x)+6{\lambda''(x)}^2\lambda^2(x)
+ 8\lambda'(x)\lambda'''(x)\lambda^2(x) -\lambda^{(4)}(x)\lambda^3(x)\Bigr ) }
}
\value{
the value of the adaptive bandwidth
}

\references{
  Bagkavos and Patil (2009), Variable Bandwidths for Nonparametric Hazard Rate Estimation, Communications in Statistics - Theory and Methods, 38:7, 1055-1078 <doi:/10.1080/03610920802364088>
}



\seealso{ \code{\link{HazardRateEst}, \link{TransHazRateEst}, \link{PlugInBand} } }

\examples{
library(survival)
x<-seq(0, 5,length=100) #design points where the estimate will be calculated

SampleSize <- 100

ti<- rweibull(SampleSize, .6, 1)#draw a random sample from the actual distribution
ui<-rexp(SampleSize, .05)       #draw a random sample from the censoring distribution
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)                 #this is the observed sample
cen<-rep.int(1, SampleSize)     #censoring indicators
cen[which(ti>ui)]<-0            #censored values correspond to zero

h2<-DefVarBandRule(ti, cen)     #Deafult Band. Rule - Weibull Reference
}

\name{VarBandHazEst}
\alias{VarBandHazEst}
\title{Variable Bandwidth Hazard Rate Estimator}

\description{
Implements the adaptive variable bandwidth hazard rate estimator of Bagkavos and Patil (2009) <doi:/10.1080/03610920802364088>. The estimate itself is an extension of the classical kernel hazard rate estimator of \href{https://projecteuclid.org/download/pdf_1/euclid.aos/1176346265}{Tanner and Wong (1983)} implemented in \code{\link{HazardRateEst}}. The difference is that instead of \eqn{h}, the variable bandwidth estimate uses bandwidth \eqn{h \lambda(X_i)^{-1/2}}. This particular choice cancels the second order term in the bias expansion of the hazard rate estimate and thus it is expected to result in a more precise estimation compared to \code{\link{HazardRateEst}}.
}

\usage{VarBandHazEst(xin, xout, kfun, h1, h2, ci)}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
 \item{xout}{A vector of points at which the hazard rate function will be estimated. }
\item{kfun}{Kernel function to use. Supported kernels: Epanechnikov, Biweight, Gaussian, Rectangular, Triangular, HigherOrder}
 \item{h1}{A scalar, pilot bandwidth. }
 \item{h2}{A scalar, variable kernel (adaptive) bandwidth.}
 \item{ci}{A vector of censoring indicators: 1's  indicate uncensored observations, 0's correspond to censored obs.}
}

\details{
Implements the adaptive variable bandwidth hazard rate estimator of Bagkavos and Patil (2009), Comm. Statist. Theory and Methods.
\deqn{\hat \lambda_v(x;h_1, h_2) = \sum_{i=1}^n \hat \lambda^{-1/2}(x;h_1 ) \frac{K_{h_2}\left \{ (x-X_{(i)})\hat \lambda^{-1/2}(x;h_1 ) \right \}\delta_{(i)}}{n-i+1}}{\lambda_v(x;h_1, h_2).}
The pilot bandwidth \eqn{h_1} is determined by an optimal bandwidth rule such as \code{\link{PlugInBand}} and used as input to the pilot kernel estimate, implemented by \code{\link{HazardRateEst}}.

The default variable bandwidth rule, \code{\link{DefVarBandRule}} with reference to the Weibull distribution  is used for the adaptive bandwidth \eqn{h_2}.
}

\value{
A vector with the values of the function at the designated points xout.
}

\references{
 Bagkavos and Patil (2009), Variable Bandwidths for Nonparametric Hazard Rate Estimation, Communications in Statistics - Theory and Methods, 38:7, 1055-1078 <doi:/10.1080/03610920802364088>
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\note{
%%  ~~further notes~~
%}

\seealso{ \code{\link{HazardRateEst}, \link{TransHazRateEst}, \link{PlugInBand} } }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated
plot(x, HazardRate(x, "weibull", .6, 1),  type="l",
     xlab = "x", ylab="Hazard rate") #plot true hazard rate function
SampleSize <- 100
mat<-matrix(nrow=SampleSize, ncol=20)
for(i in 1:20)
{
  ti<- rweibull(SampleSize, .6, 1)#draw a random sample from the actual distribution
  ui<-rexp(SampleSize, .05)       #draw a random sample from the censoring distribution
  cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
  x1<-pmin(ti,ui)                 #this is the observed sample
  cen<-rep.int(1, SampleSize)     #censoring indicators
  cen[which(ti>ui)]<-0            #censored values correspond to zero

  h2<-DefVarBandRule(ti, cen)     #Deafult Band. Rule - Weibull Reference
  huse1<-  PlugInBand(x1, x,   cen, Biweight)
  mat[,i]<- VarBandHazEst(x1, x, Epanechnikov, huse1,h2, cen) #Var. bandwidth est.
}
lines(x, rowMeans(mat) , lty=2)   #draw the average  vb estimate
}

\name{Kernels}
\alias{Biweight}
\alias{Epanechnikov}
\alias{Triangular}
\alias{Gaussian}
\alias{HigherOrder}
\alias{Rectangular}
\alias{IntBiweight}
\alias{IntEpanechnikov}
\alias{IntRectangular}
\alias{IntTriangular}
\alias{IntGaussian}
\alias{SDBiweight}
\alias{a0}
\alias{a1}
\alias{a2}
\alias{BoundaryBiweight}
\alias{b0}
\alias{b1}
\alias{b2}
\alias{BoundaryEpanechnikov}
\alias{Habbema}

\title{Kernel functions}

\description{
Implements various kernel functions, including boundary, integrated and discrete kernels for use in the definition of the nonparametric estimates
}

\usage{
Biweight(x, ...)
Epanechnikov(x, ...)
Triangular(x, ...)
Gaussian(x, ...)
HigherOrder(x, ...)
Rectangular(x, ...)
IntBiweight(x)
IntEpanechnikov(x)
IntRectangular(x)
IntTriangular(x)
IntGaussian(x)
SDBiweight(x)
a0(x,h)
a1(x,h)
a2(x,h)
BoundaryBiweight(x, h)
b0(x,h)
b1(x,h)
b2(x,h)
BoundaryEpanechnikov(x, h)
Habbema(xin, x)
}

\arguments{
\item{x}{ A vector of data points where the kernel will be evaluated.}
\item{h}{A scalar.}
\item{xin}{Discrete data inputs especially for the Habbema discrete kernel.}
\item{...}{Further arguments.}
}

\details{
Implements the Biweight, Second Derivative Biweight,  Epanechnikov, Triangular, Guassian, Rectangular, the Boundary adjusted Biweight and Epanechnikov kernels. It also provides the kernel distribution functions for the Biweight, Epanechnikov, Rectangular, Triangular and Guassian kernels. Additionally it implements the discrete kernel Habbema.
}

\value{
The value of the kernel at \eqn{x}
}

\references{
\enumerate{
\item \href{https://ieeexplore.ieee.org/document/4385743}{Bagkavos and Patil, Local Polynomial Fitting in Failure Rate Estimation, IEEE Transactions on Reliability, 57, (2008)},
\item \href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011),  Annals of the Institute of Statistical Mathematics, 63(5), 1019-1046},
}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\note{
%%  ~~further notes~~
%}

%\seealso{
%\code{\link{alfa.profile}, \link{alfa}, \link{alfainv}, \link{alpha.mle}
%}
%}

%\examples{
%
%}

\name{cvfunction}
\title{Cross Validation for Histogram Hazard Rate Estimator}
\alias{cvfunction}
\description{
Implements the cross validation function for determining the optimal number of bins for the histogram hazard rate estimator of \href{https://www.jstor.org/stable/42003749}{ Patil and Bagkavos (2012)}. It is used as input in   \code{\link{HazardHistogram}}.
}

\usage{
cvfunction(h, xin, xout, cens)
}

\arguments{
\item{h}{Target number of bins.}
\item{xin}{ A vector of data points.  Missing values not allowed.}
\item{xout}{ A vector of grid points at which the histogram will be calculated.}
 \item{cens}{ A vector of 1s and zeros, 1's indicate uncensored observations, 0's correspond to censored obs. }
}

\details{
The least square cross validation criterion, defined in (12), \href{https://www.jstor.org/stable/42003749}{Patil and Bagkavos (2012)} is
\deqn{
CV (h) = \frac{1}{h}\sum_k \big\{(2 f^0_k - f^{0^2}_k)[\bar F_k (\bar F_k +1)]^{-1} - f^{0^2}_k[\bar F_k (\bar F_k +1)^2]^{-1}\big\}.
}
Optimization of the criterion is done through a nonlinear optimization function such as \code{\link{nlminb}} as illustrated also in the example of \code{\link{HazardHistogram}}.
}

\value{
Returns the optimal number of bins.
}

\references{
\href{https://www.jstor.org/stable/42003749}{Patil and Bagkavos (2012), Histogram for hazard rate estimation,  pp. 286-301, Sankhya, B.}

}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\note{
%%  ~~further notes~~
%}

\seealso{
\code{\link{HazardHistogram}
}
}

\name{LocLinEst}
\title{Local Linear Hazard Rate Estimator}
\alias{LocLinEst}
\description{Implements the local linear kernel hazard rate estimate of \href{https://ieeexplore.ieee.org/document/4385743}{Bagkavos and Patil (2008)} and \href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011)}. The estimate assumes binned data (fixed design), of the form \eqn{(x_i, y_i)} where \eqn{x_i} are the bin centers and \eqn{y_i} are empirircal hazard rate estimates at each \eqn{x_i}. These are calculated  via  the \code{\link{DiscretizeData}} function. The estimate then smooths the empircal hazard rate estimates and achieves  automatic  boundary adjustments through approrpiately defined kernel weights. The user is able to supply their own bandwidth values through the \eqn{h} argument.

Currently only the \code{\link{LLHRPlugInBand}} bandwidth selector is provided which itself it depends on the \code{\link{bw.nrd}} distribution function default bandwidth rule of \href{https://onlinelibrary.wiley.com/doi/abs/10.1111/j.1467-9469.2005.00472.x}{Swanepoel and Van Graan (2005)} for the constant estimate.
\itemize{
\item TO DO: In future implementations the EBBS (empirical bias bandwidth) and AIC based bandwidth methods (see \href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011)}) will be added to the package}
}

\usage{
LocLinEst(BinCenters, xout, h, kfun, ci)
}

\arguments{
\item{BinCenters}{ A vector with the bin centers of the discretized data.}
 \item{xout}{ A vector of points at which the hazard rate function will be estimated. }
 \item{h}{ A scalar, the bandwidth to use in the estimate. }
 \item{kfun}{ Kernel function to use. Supported kernels: Epanechnikov, Biweight, Gaussian, Rectangular, Triangular}
 \item{ci}{ Empirical hazard rate estimates.}
}

\details{
The estimate in both \href{https://ieeexplore.ieee.org/document/4385743}{Bagkavos and Patil (2008)} and \href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011)} is given by
\deqn{
 \hat \lambda_L(x)= \frac{T_{n,1}(x) S_{n,1}(x) - T_{n,0}(x) S_{n,2}(x)}{S_{n,1}(x)S_{n,1}(x)-S_{n,0}(x)S_{n,2}(x)}.
}
The difference between the censored and the uncensored cased is only on the calculation of the empirical hazard rate estimates.
}

\value{
A vector with the values of the function at the designated points xout.
}

\references{
\enumerate{
\item \href{https://ieeexplore.ieee.org/document/4385743}{Bagkavos and Patil, Local Polynomial Fitting in Failure Rate Estimation, IEEE Transactions on Reliability, 57, (2008)},
\item \href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011),  Annals of the Institute of Statistical Mathematics, 63(5), 1019-1046},
}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\note{
%%  ~~further notes~~
%}

\seealso{ \code{\link{HazardRateEst}, \link{LLHRPlugInBand} }}

\examples{
x<-seq(0.05, 5,length=80) #grid points to calculate the estimates
plot(x, HazardRate(x,"weibull", .6, 1),type="l", xlab = "x",ylab="Hazard rate")

SampleSize = 100                 #select sample size
ti<- rweibull(SampleSize, .6, 1) # draw a random sample
ui<-rexp(SampleSize, .2)         # censoring sample
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)                  # observed data
cen<-rep.int(1, SampleSize)      # initialize censoring indicators
cen[which(ti>ui)]<-0             # 0's correspond to censored indicators

a.use<-DiscretizeData(ti, x)     # discretize the data
BinCenters<-a.use$BinCenters     # get the data centers
ci<-a.use$ci                     # get empircal hazard rate estimates
Delta=a.use$Delta                # Binning range
h2<-bw.nrd(ti)                   # Bandwidth to use in constant est. of the plug in rule
h.use<-h2                        # the first element is the band to use

# Calcaculate the plug-in bandwidth:
huse1<- LLHRPlugInBand(BinCenters,h.use,Epanechnikov,Delta,ti,x,IntEpanechnikov,ci, cen)
arg2<-HazardRateEst(x1,x,Epanechnikov, huse1, cen)      # Tanner-Wong Estimate
lines(x, arg2, lty=2) # draw the Tanner-Wong   estimate # Draw TW estimate
arg5<-HazardRateEst(x1,x,BoundaryBiweight,huse1,cen)    # Boundary adjusted TW est
lines(x, arg5, lty=2, col=4) # draw the variable bandwidth # Draw the estimate
arg6<-LocLinEst(BinCenters ,x, huse1, Epanechnikov, ci) # Local linear est.
lines(x, arg6, lty=5, col=5)                             # Draw the estimate
legend("topright", c("Tanner-Wong",  "TW - Boundary Corrected", "Local Linear"),
          lty=c(2,2, 5), col=c(1,4, 5)) # add legend
}

\name{l1-l4, lw, lwF, gx}
\alias{l1}
\alias{l2}
\alias{l3}
\alias{l4}
\alias{lw}
\alias{lwF}
\alias{gx}
\title{Weibull hazard rate functionals}

\description{
Privides the various hazard rate function derivatives and related functionals with reference to the Weibull function
}

\usage{
l1(x,p,l)
l2(x,p,l)
l3(x,p,l)
l4(x,p,l)
lw(x,p,l)
lwF(x,p,l)
gx(x,p,l)
}

\arguments{
 \item{x}{A vector of points at which the hazard rate function will be estimated. }
\item{p}{MLE estimate of the shape parameter}
 \item{l}{MLE estimate of the scale parameter}
}

\details{
Implements the necessary functions for calculating the squared bias term of the variable bandwidth estimate.


}

\value{
A vector with the values of the function at the designated points x.
}

\references{
 Bagkavos and Patil (2009), Variable Bandwidths for Nonparametric Hazard Rate Estimation, Communications in Statistics - Theory and Methods, 38:7, 1055-1078 <doi:/10.1080/03610920802364088>
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\note{
%%  ~~further notes~~
%}

%\seealso{ \code{\link{HazardRateEst}, \link{TransHazRateEst}, \link{PlugInBand} } }

%\examples{
%x<-seq(0, 5,length=100) #design points where the estimate will be calculated
%plot(x, HazardRate(x, "weibull", .6, 1),  type="l",
%     xlab = "x", ylab="Hazard rate") #plot true hazard rate function
%SampleSize <- 100
%mat<-matrix(nrow=SampleSize, ncol=20)
%for(i in 1:20)
%{
%  ti<- rweibull(SampleSize, .6, 1)#draw a random sample from the actual distribution
%  ui<-rexp(SampleSize, .05)       #draw a random sample from the censoring distribution
%  cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
%  x1<-pmin(ti,ui)                 #this is the observed sample
%  cen<-rep.int(1, SampleSize)     #censoring indicators
%  cen[which(ti>ui)]<-0            #censored values correspond to zero
%
%  h2<-BandsIkde(ti)               #temporary default rule for var. bandwidth
%  h2<-h2[2]                       #extract the temp bandwidth
%  huse1<-  PlugInBand(x1, x,   cen, Biweight)
%  mat[,i]<- VarBandHazEst(x1, x, Epanechnikov, huse1,h2, cen) #Var. bandwidth est.
%}
%lines(x, rowMeans(mat) , lty=2)   #draw the average  vb estimate
%}

\name{TransHazRateEst}
\alias{TransHazRateEst}
\title{Transformation Based Hazard Rate Estimator}

\description{
Implements the transformated kernel hazard rate estimator of Bagkavos (2008) <doi:/10.1080/10485250802440184>. The estimate is expected to have less bias compared to the ordinary kernel estimate \code{\link{HazardRateEst}}. The estimate results by first transforming the data to a sample from the exponential distribution through the integrated hazard rate function, estimated by \code{\link{iHazardRateEst}} and uses the result as input to the classical kernel hazard rate estimate  \code{\link{HazardRateEst}}. An inverse transform turn the estimate to a hazard rate estimate of the original sample. See section "Details" below.
}

\usage{
TransHazRateEst(xin, xout, kfun, ikfun, h1, h2, ci)
}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
 \item{xout}{A vector of points at which the hazard rate function will be estimated. }
\item{kfun}{Kernel function to use. Supported kernels: Epanechnikov, Biweight, Gaussian, Rectangular, Triangular, HigherOrder.}
\item{ikfun}{An integrated kernel function to use. Supported kernels: Epanechnikov, Biweight, Gaussian, Rectangular, Triangular, HigherOrder.}
\item{h1}{A scalar, pilot bandwidth.}
\item{h2}{A scalar, transformed kernel bandwidth.}
 \item{ci}{A vector of censoring indicators: 1's indicate uncensored observations, 0's correspond to censored obs. }
}

\details{
The transformed kernel hazard rate estimate of  Bagkavos (2008) <doi:/10.1080/10485250802440184> is given by
\deqn{\hat \lambda_t(x;h_1, h_2) = \sum_{i=1}^n  \frac{K_{h_2}\left \{ (\hat \Lambda(x;h_1 ) - \hat \Lambda(X_{(i)};h_1 ) ) \right \}\delta_{(i)}}{n-i+1}\hat \lambda(x;h_1 ).}{\lambda_t(x;h_1, h_2).}
The estimate uses the classical kernel hazard rate estimate \eqn{\lambda(x; h_1)} implemented in \code{\link{HazardRateEst}} and its integrated version
\deqn{\hat \Lambda(x; h_1) =  \sum_{i=1}^n \frac{k\left \{(x-X_{(i)})h_1^{-1}\right \}\delta_{(i)}}{n-i+1}}{\Lambda(x; h_1) = \int_{-\infty}^x \lambda(t;h_1)dt}
 where
\eqn{k(x) = \int_{-\infty}^x K(y)\,dy}
implemented in \code{\link{iHazardRateEst}}. The pilot bandwidth \eqn{h_1} is determined by an optimal bandwidth rule such as \code{\link{PlugInBand}}.

The default variable bandwidth rule, \code{\link{DefVarBandRule}} with reference to the Weibull distribution  is used for the adaptive bandwidth \eqn{h_2}
}

\value{
A vector with the values of the function at the designated points xout.
}

\references{
 Bagkavos (2008), Transformations in hazard rate estimation, J. Nonparam. Statist., 20, 721-738 <doi:/10.1080/10485250802440184>
}



\seealso{ \code{\link{VarBandHazEst}, \link{HazardRateEst}, \link{PlugInBand} } }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated
plot(x, HazardRate(x, "weibull", .6, 1),  type="l",
                   xlab = "x", ylab="Hazard rate") #plot true hazard rate function
SampleSize <- 100
mat<-matrix(nrow=SampleSize, ncol=20)
for(i in 1:20)
{ #Calculate the average of 20 estimates and draw on the screen
 ti<- rweibull(SampleSize, .6, 1)  #draw a random sample from the actual distribution
 ui<-rexp(SampleSize, .05)          #draw a random sample from the censoring distribution
 cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
 x1<-pmin(ti,ui)                   #this is the observed sample
 cen<-rep.int(1, SampleSize)       #censoring indicators
 cen[which(ti>ui)]<-0              #censored values correspond to zero

 h2<-DefVarBandRule(ti, cen)     #Deafult Band. Rule - Weibull Reference
 huse1<- PlugInBand(x1, x,   cen, Biweight) #
 mat[,i]<-TransHazRateEst(x1,x,Epanechnikov,IntEpanechnikov,huse1,h2,cen)
}
lines(x, rowMeans(mat) , lty=2) #draw the average transformed estimate
}

\name{sn.i, tn.i}
\title{Local kernel weights}
\alias{sn.0}
\alias{sn.1}
\alias{sn.2}
\alias{sn.3}
\alias{sn.4}
\alias{sn.5}
\alias{sn.6}
\alias{tn.0}
\alias{tn.1}
\alias{tn.2}
\alias{tn.3}
\description{
Implements the local kernel weights which are used in the implementation of \code{\link{LocLinEst}} and the second derivative estimate used in \code{\link{PlugInBand}}.
}

\usage{
sn.0(xin, xout, h, kfun)
sn.1(xin, xout, h, kfun)
sn.2(xin, xout, h, kfun)
sn.3(xin, xout, h, kfun)
sn.4(xin, xout, h, kfun)
sn.5(xin, xout, h, kfun)
sn.6(xin, xout, h, kfun)
tn.0(xin, xout, h, kfun, Y)
tn.1(xin, xout, h, kfun, Y)
tn.2(xin, xout, h, kfun, Y)
tn.3(xin, xout, h, kfun, Y)
}

\arguments{
\item{xin}{ A vector of data points, typicaly these are the bin centers.  Missing values not allowed.}
 \item{xout}{ A vector of data points where the estimate will be evaluated.}
\item{h}{A scalar. The bandwidth to use.}
\item{kfun}{The kernel function to use.}
\item{Y}{Empirical hazard rate estimates.}
}

\details{
The functions calculate the quantities
\deqn{S_{n,l}(x) = \sum_{i=1}^n K \left (\frac{x_i-x}{h}\right ) (x_i-x)^l, l=0,\dots,6 }
and
\deqn{T_{n,l}(x) = \sum_{i=1}^n K \left (\frac{x_i-x}{h}\right ) (x_i-x)^l Y_i, l=0,\dots,3}
These qunatities are used to adjust the hazard rate estimate and its second derivative in the boundary.
}

\value{
The weight of the functional at \eqn{x}
}

\references{
\enumerate{
\item \href{https://ieeexplore.ieee.org/document/4385743}{Bagkavos and Patil, Local Polynomial Fitting in Failure Rate Estimation, IEEE Transactions on Reliability, 57, (2008)},
\item \href{https://link.springer.com/article/10.1007/s10463-010-0277-6}{Bagkavos (2011),  Annals of the Institute of Statistical Mathematics, 63(5), 1019-1046}.
}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

\name{SDHazardRateEst}
\title{Kernel Second Derivative Hazard Rate Estimation}
\alias{SDHazardRateEst}
\description{
Implements the kernel estimate of the second derivative of the hazard rate for right censored data defined - based on the estimate of \href{https://projecteuclid.org/download/pdf_1/euclid.aos/1176346265}{Tanner and Wong (1983)}. The implementation is based on the second derivative of the Biweight Kernel.
}

\usage{
SDHazardRateEst(xin, xout, h, ci)
}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
 \item{xout}{A vector of grid points at which the estimates will be calculated. }
 \item{h}{A scalar, the bandwidth to use in the estimate. }
 \item{ci}{A vector of censoring indicators: 1's indicate uncensored observations, 0's correspond to censored obs.}
}

\details{
The function \code{\link{SDHazardRateEst}} implements the kernel estimate of the second derivative of the hazard rate estimator, given by
\deqn{\hat \lambda_2(x;h) = \sum_{i=1}^n \frac{K_h''(x-X_{(i)})\delta_{(i)}}{n-i+1}}
where \eqn{K} is taken to be the \code{\link{Biweight}} kernel. The function is used for estimation of the functional \eqn{R(\lambda'')} in \code{\link{PlugInBand}} so a default bandwidth rule is used for \eqn{h} provided in (16), \href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos (2018)}.
}


\value{
A vector with the second derivative of the hazard rate at the designated points xout.
}

\references{
\enumerate{
\item \href{https://projecteuclid.org/download/pdf_1/euclid.aos/1176346265}{Tanner and Wong (1983), The Estimation Of The Hazard Function From Randomly Censored Data By The Kernel Method, Annals of Statistics,  3, pp. 989-993.}
\item \href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos, An $L_1$ analysis of a kernel-based hazard rate estimator, Australian and New Zealand J. Statist., (60), 43-64, (2018).}
}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\seealso{ \code{\link{VarBandHazEst}, \link{TransHazRateEst}, \link{PlugInBand}} }

%\examples{
%x<-seq(0, 5,length=100) #design points where the estimate will be calculated
%plot(x, HazardRate(x, "weibull", .6, 1),  type="l", xlab = "x",
%                   ylab="Hazard rate") #plot true hazard rate function
%SampleSize <- 100
%ti<- rweibull(SampleSize, .6, 1)  #draw a random sample from the actual distribution
%ui<-rexp(SampleSize, .2)  #draw a random sample from the censoring distribution
%cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
%x1<-pmin(ti,ui)             #this is the observed sample
%cen<-rep.int(1, SampleSize) #censoring indicators
%cen[which(ti>ui)]<-0        #censored values correspond to zero
%huse<-PlugInBand(x1, x,   cen, Biweight)
%arg2<-HazardRateEst(x1, x, Epanechnikov, huse, cen) #Calculate the estimate
%lines(x, arg2, lty=2)       #draw the result on the graphics device.
%}

\name{PlugInBand}
\title{Simple Plug in badnwidth selector}
\alias{PlugInBand}
\description{
Provides  the asymptotic MISE optimal plug-in bandwidth for the hazard rate estimator \code{\link{HazardRateEst}}, see \href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos (2018).}  The bandwidth is also suitable for use   as a pilot bandwidth in  \code{\link{TransHazRateEst} } and \code{\link{VarBandHazEst}}.}


\usage{PlugInBand(xin, xout,   cens, kfun ) }

\arguments{
 \item{xin}{ A vector of data points}
 \item{xout}{ The point at which the estimates should be calculated.}
\item{cens}{ Censoring Indicators.}
\item{kfun}{ A kernel function. }
}

\details{
The asymptotic MISE optimal plug-in bandwidth selector for \code{\link{HazardRateEst}} is defined by
\deqn{h_{ opt} = \left[\frac{R(K)}{nR(\lambda_T'')\mu_{2,K}^2}\int \frac{\lambda_T(x)}{1-F(x)}\,dx \right]^{1/5} }
see (9) in \href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos (2018)}. The   estimate of \eqn{R(\lambda_T'')} to be used in \eqn{h_{opt}} is
\deqn{
R(\hat \lambda_T'') = \int_0^\xi \left (\hat \lambda_T''(x|\hat b_n^\ast) \right )^2\,dx.
 }
Also,
\deqn{ \int_0^T \frac{\lambda_T(x)}{1-F(x)}\,dx }
is estimated by applying the extended Simpson's numerical integration rule, \code{\link{SimpsonInt}}, on
\deqn{
 \frac{\hat \lambda_T(x|\hat b_n^\ast)  }{1-F(x)}
 }
 where \eqn{1-F(x)} is estimated by \code{\link{KMest}}. The estimation is implemented in the \code{\link{NP.M.Estimate}} function.

Currently \eqn{b_n^\ast} is estimated by \code{\link{bw.nrd}}. However according to (11) in \href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos (2018).}, in future versions this package will support
\deqn{
b_n^\ast = \left \{ \frac{5R(K'')}{n \mu_{2,K}^2 R(\lambda_T^{(4)})} \int \frac{\lambda_T(x)}{1-F(x)}\,dx  \right \}^{1/9}.}
where
\deqn{
R(\hat  \lambda_T^{(4)}) =  \frac{(\hat a(\hat a-1)(\hat a-2)(\hat a-3)(\hat a-4))^2}{(2\hat a-9){\hat{b}}^{2\hat a} } (\xi^{2\hat a-9} - {p_\alpha}^{2\hat a-9}), \hat a\neq 9/2
}
and \eqn{\hat M} is already estimated by \code{\link{NP.M.Estimate}} as expalined above (it will be much more stable than using a Weibull reference model).
}

\value{
A scalar with the value of the suggested bandwidth.
}

\references{
\href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos, An $L_1$ analysis of a kernel-based hazard rate estimator, Australian and New Zealand J. Statist., (60), 43-64, (2018).}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}



\seealso{ \code{\link{HazardRateEst}, \link{LLHRPlugInBand} } }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated
SampleSize<-100 #amount of data to be generated
ti<- rweibull(SampleSize, .6, 1) # draw a random sample
ui<-rexp(SampleSize, .2)         # censoring sample
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)                  # observed data
cen<-rep.int(1, SampleSize)      # initialize censoring indicators
cen[which(ti>ui)]<-0             # 0's correspond to censored indicators

huse1<- PlugInBand(x1, x, cen, Biweight)
huse1


}

\name{nsf, Tm, CparamCalculation, power.matrix, base, SmoothedEstimate}
\title{Auxiliary functions for discrete hazard rate estimators}
\alias{nsf}
\alias{Tm}
\alias{CparamCalculation}
\alias{power.matrix}
\alias{base}
\alias{SmoothedEstimate}

\description{
Auxiliary functions for discrete semiparametric and kernel smooth hazard rate estimation
}

\usage{
 nsf(xin, cens, xout)
 Tm(tk, xout, distribution, par1, par2)
 CparamCalculation(gamparam, VehHazard)
 power.matrix(M, n)
 base(m, b)
 SmoothedEstimate(NonParEst, VehHazard, gammapar, SCproduct, Cpar)
}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
\item{cens}{A vector of 1s and zeros, 1's indicate uncensored observations, 0's correspond to censored obs. }
\item{xout}{The points where the estimate should be calculated.}
\item{tk}{desing points for the NPMLE estimate.}
\item{distribution}{which distribution to use?}
\item{par1}{distribution parameter 1}
\item{par2}{distribution parameter 2}
\item{gamparam}{gamma parameter}
\item{M}{a matrix to be raised to a power}
\item{n}{the power the matrix will be raised at}
\item{m}{express m as a power of b}
\item{b}{express m as a power of b}
\item{NonParEst}{The crude nonparametric hazard rate estimate.}
\item{VehHazard}{Vehicle hazard rate}
\item{gammapar}{gamma parameter }
\item{SCproduct}{SC product, the result of DetermineSCprod}
\item{Cpar}{C parameter, the result of CparamCalculation.}
}

\details{
Auxiliary functions for discrete hazard rate estimators. The function \code{nsf} is used for the kernel smooth estimate \code{\link{TutzPritscher}}.
\describe{
\item{Tm}{ used to calculate \eqn{\max(t_k; 1-\sum_{l=0}^k \eta_l > \epsilon), \epsilon>0} in the implementation of the semiparametric estimate}
\item{CparamCalculation}{returns the C smoothing parameter calculated as \eqn{C= \gamma/\max_{k \geq 0} ( \lambda(t_{k-1}) + \lambda(t_k) + \lambda(t_{k+1}) )}}
\item{DetermineSCprod}{this finds \eqn{SC = \gamma((n+1) \hat B_1)^{-1} \hat V_1}  n = number of obs, gammapar = sum of vehicle haz at xout (computed elsewhere)}
}
}

\value{
A vector with the values of the hazard rate estimates.
}

\references{
\enumerate{
\item \href{https://onlinelibrary.wiley.com/doi/abs/10.1002/bimj.201100058}{Patil and Bagkavos (2012), Semiparametric smoothing of discrete failure time data,  Biometrical Journal, 54, (2012), 5--19.}
\item  Tutz, G. and Pritscher, L. Nonparametric Estimation of Discrete Hazard Functions, Lifetime Data Anal, 2, 291-308 (1996) <doi:/10.1007/BF00128979>
}
}

\name{KMest}
\title{Kaplan-Meier Estimate}
\alias{KMest}
\description{
Custom implementation of the Kaplan Meier estimate. The major difference with existing implementations is that the user can specify exactly the grid points where the estimate is calculated. The implementation corresponds to \eqn{1-\hat H(x)} of \href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos (2018)}, and is used mainly for estimation of the censoring distribution.
}

\usage{KMest(xin, cens, xout) }

\arguments{
 \item{xin}{ A vector of data points}
 \item{xout}{ The point at which the estimates should be calculated.}
\item{cens}{ Censoring Indicators.}
}

\details{
Calculates the well known Kaplan-Meier estimate
\deqn{1-\hat H(x) =  1,   0 \leq x \leq X_{(1)}} or
\deqn{
1-\hat H(x) = \prod_{i=1}^{k-1} \left ( \frac{n-i+1}{n-i+2} \right )^{1-\delta_{(i)}},   X_{(k-1)} <x \leq X_{(k)}, k=2,\dots,n } or
\deqn{
1-\hat H(x) = \prod_{i=1}^{n} \left ( \frac{n-i+1}{n-i+2} \right )^{1-\delta_{(i)}},  X_{(n)}<x.}
The implementation is mainly for estimating the censoring distribution of the available sample.
}

\value{
A vector with the Kaplan-Meier estimate at xout.
}

\references{
\href{https://www.jstor.org/stable/2281868}{Kaplan, E. L., and Paul Meier. Nonparametric Estimation from Incomplete Observations., J. of the American Statist. Association 53, (1958): 457-81.}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}



%\seealso{ \code{\link{HazardRateEst}, \link{LLHRPlugInBand} } }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated
SampleSize<-100 #amount of data to be generated
ti<- rweibull(SampleSize, .6, 1) # draw a random sample
ui<-rexp(SampleSize, .2)         # censoring sample
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)                  # observed data
cen<-rep.int(1, SampleSize)      # initialize censoring indicators
cen[which(ti>ui)]<-0             # 0's correspond to censored indicators

arg1<- KMest(x1, cen, x)
plot(x, arg1, type="l")
}

\name{SemiparamEst}
\title{Discrete hazard rate estimator}
\alias{SemiparamEst}


\description{
Implements the semiparametric hazard rate estimator for discrete data developed in \href{https://onlinelibrary.wiley.com/doi/abs/10.1002/bimj.201100058}{Patil and Bagkavos (2012)}. The estimate is obtained by semiparametric smoothing of the (nonsmooth) nonparametric maximum likelihood estimator, which is achieved by repeated multiplication of a Markov chain transition-type matrix. This matrix is constructed with basis
a parametric discrete hazard rate model (vehicle model). }

\usage{
SemiparamEst(xin, cens, xout, Xdistr, Udistr, vehicledistr, Xpar1=1, Xpar2=0.5,
              Upar1=1, Upar2=0.5, vdparam1=1, vdparam2=0.5)
}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
\item{cens}{Censoring indicators as a vector of 1s and zeros, 1's indicate uncensored observations, 0's correspond to censored obs. }
\item{xout}{Design points where the estimate will be calculated.}
\item{Xdistr}{The distribution where the data are coming from, currently ignored}
\item{Udistr}{Censoring distribution, currently ignored}
\item{vehicledistr}{String specifying the vehicle hazard rate (the assumed parametric model)}
\item{Xpar1}{Parameter 1 for the X distr, currently ignored}
\item{Xpar2}{Parameter 2 for the X distr, currently ignored}
\item{Upar1}{Parameter 1 for the Cens. distr., currently ignored}
\item{Upar2}{Parameter 2 for the Cens. distr., currently ignored}
\item{vdparam1}{Parameter 1 for the vehicle hazard rate. }
\item{vdparam2}{Parameter 2 for the vehicle hazard rate.}
}

\details{
The semiparmaetric estimator implemented is defined in (1) in \href{https://onlinelibrary.wiley.com/doi/abs/10.1002/bimj.201100058}{Patil and Bagkavos (2012)} by
\deqn{\tilde \lambda  = \hat \lambda \Gamma^S}{\tilde \lambda  = \hat \lambda \Gamma^S}
where \eqn{S} determines the number of repetions and hence the amount of smoothing applied to the estimate. For \eqn{S=0} the semiparametric estimate equals the nonparmaetric estimate \code{\link{lambdahat}}. On the other hand, if the true unknown underlying probability model is known (up to an unknown constant or constants) then, the greater the \eqn{S}, the closer the semiparmaetric estimate to the vehicle hazard rate model.

\itemize{
\item  TO DO: The extension to hazard rate estimation with covariates will be added in a future release.
\item TO DO: Also, the data driven estimation of the parameter \eqn{S} will be also added in a future release; this will inlcude the \eqn{SC} product and \eqn{C} and \eqn{\gamma} parameter calculations.
}
}


\value{
A vector with the values of the discrete hazard rate estimate, calculated at \eqn{x=xout}.
}

\references{
\href{https://onlinelibrary.wiley.com/doi/abs/10.1002/bimj.201100058}{Patil and Bagkavos (2012), Semiparametric smoothing of discrete failure time data,  Biometrical Journal, 54, (2012), 5-19}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\note{
%%  ~~further notes~~
%}

\seealso{\code{\link{lambdahat}, \link{TutzPritscher}}}

\examples{
options(echo=FALSE)
xin<-c(7,34,42,63,64, 74, 83, 84, 91, 108, 112,129, 133,133,139,140,140,146,
      149,154,157,160,160,165,173,176,185, 218,225,241, 248,273,277,279,297,
      319,405,417,420,440, 523,523,583, 594, 1101, 1116, 1146, 1226, 1349,
      1412, 1417) #head and neck data set
cens<-c(1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
        1,0,1,1,1,1,1,1,0,1,0,1,1,1,1,1,0,1,1,1,0,1) #censoring indicators
xin<-xin/30.438 #mean adjust the data
storage.mode(xin)<-"integer"  # turn the data to integers
xout<-seq(1,47, by=1) #design points where to calculate the estimate
arg<-TutzPritscher(xin,cens,xout) #Kernel smooth estimate
plot(xout, arg, type="l", ylim=c(0, .35), lty=2,  col=6)
argSM<-SemiparamEst(xin, cens, xout, "geometric", "uniform",
                    "geometric", 0.2, .6, 0, 90, .25, .9) #semipar. est.
lines(xout, argSM[,2], lty=3, col=5) #add tilde lambda to the plot
}

\name{DiscretizeData}
\title{Discretize the available data set}
\alias{DiscretizeData}

\description{
Defines equispaced disjoint intervals based on the range of the sample and calculates empirical hazard rate estimates at each interval center
}


\usage{
DiscretizeData(xin, xout)
}

\arguments{
\item{xin}{A vector of input values}
\item{xout}{Grid points where the function will be evaluated}
}

\details{The function defines the subinterval length \eqn{\Delta = (0.8\max(X_i) - \min(X_i))/N} where \eqn{N} is the sample size. Then at each bin (subinterval) center, the empirical hazard rate estimate is calculated by
\deqn{
c_i = \frac{f_i}{\Delta(N-F_i +1) }
}
where \eqn{f_i} is the frequency of observations in the ith bin and \eqn{F_i = \sum_{j\leq i} f_j} is the empirical cummulative distribution estimate.
}

\value{
A vector with the values of the function at the designated points xout or the random numbers drawn.
}

%\references{
%Bagkavos, Dimitrios and Patil, Prakash (2009) Variable Bandwidths for Nonparametric Hazard Rate Estimation, Communications in Statistics - %Theory and Methods, 38, 1055-1078, http://dx.doi.org/10.1080/03610920802364088
%}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com> }

%\note{
%%  ~~further notes~~
%}

%\seealso{ \code{\link{HazardRateEst}, \link{TransHazRateEst} } }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated
SampleSize<-100 #amount of data to be generated
ti<- rweibull(SampleSize, .6, 1) # draw a random sample
ui<-rexp(SampleSize, .2)         # censoring sample
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)                  # observed data
cen<-rep.int(1, SampleSize)      # initialize censoring indicators
cen[which(ti>ui)]<-0             # 0's correspond to censored indicators

a.use<-DiscretizeData(ti, x)     # discretize the data
BinCenters<-a.use$BinCenters     # get the data centers
ci<-a.use$ci                     # get empircal hazard rate estimates
Delta=a.use$Delta                # Binning range


}

\name{SimpsonInt}
\title{Simpson numerical integration}
\alias{SimpsonInt}

\description{
Implements Simpson's extended numerical integration rule
}

\usage{
SimpsonInt(xin, h)
}

\arguments{
\item{xin}{ A vector of data points}
\item{h}{ grid length}
}

\details{
The extended numerical integration rule is given by
\deqn{
\int_0^{x_{2n}} f(x)\,dx = \frac{h}{3}(f(x_0) + 4\{f(x_1) + \dots f(x_{2n-1}) \}
      +2 \{f(x_2) + f(x_4) + \dots f(x_{2n-2})\} + f(x_{2n})) -R_n
}
}

\value{
returns the approximate integral value
}

\references{
  \href{https://mathworld.wolfram.com/SimpsonsRule.html}{Weisstein, Eric W. "Simpson's Rule." From MathWorld--A Wolfram Web Resource}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}




%}

\name{TutzPritscher}
\title{Discrete non parametric kernel hazard rate estimator}
\alias{TutzPritscher}

\description{
Implementation of the kernel discrete hazard rate estimator of Tutz and Pritscher (1996) <doi:/10.1007/BF00128979> based on the discrete \code{\link{Habbema}} kernel.
}

\usage{
 TutzPritscher(xin, cens, xout)
}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
\item{cens}{Censoring indicators as a vector of 1s and zeros, 1's indicate uncensored observations, 0's correspond to censored obs.}
\item{xout}{The grid points where the estimates will be calculated.}
}

\details{
The discrete kernel estimate of Tutz and Pritscher (1996) <doi:/10.1007/BF00128979> is defined by
\deqn{\hat \lambda(t_m|v) = \sum_{s=1}^q \sum_{i=1}^{m_s} w_m \left ( (t,x), (s, x_{is}) \right )\tilde \lambda(s|x_{is})}{\lambda(t_m|v) =  }
where \eqn{w_m} is the discrete Habbema kernel.
}

\value{
Returns a vector with the values of the hazard rate estimates at \eqn{x=xout}.
}

\references{
 Tutz, G. and Pritscher, L. Nonparametric Estimation of Discrete Hazard Functions, Lifetime Data Anal, 2, 291-308 (1996) <doi:/10.1007/BF00128979>
}




\seealso{
\code{\link{SemiparamEst}
}
}

\examples{
options(echo=FALSE)
xin<-c(7,34,42,63,64, 74, 83, 84, 91, 108, 112,129, 133,133,139,140,140,146,
      149,154,157,160,160,165,173,176,185, 218,225,241, 248,273,277,279,297,
      319,405,417,420,440, 523,523,583, 594, 1101, 1116, 1146, 1226, 1349,
      1412, 1417)
cens<-c(1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,
        0,1,0,1,1,1,1,1,0,1,1,1,0,1)
xin<-xin/30.438    #Adjust the data
storage.mode(xin)<-"integer"  # turn the data to integers
xout<-seq(1,47, by=1)  # define the grid points to evaluate the estimate
arg<-TutzPritscher(xin,cens,xout)   #Discrete kernel estimate
plot(xout, arg, type="l", ylim=c(0, .35), lty=2,  col=6) # plot the estimate
argSM<-lambdahat(xin, cens, xout)  #crude nonparametric estimate
lines(xout, argSM, lty=3, col=5) # plot the crude estimate
}

\name{HRSurv}
\title{Estimate of the constant in the optimal AMISE expression}
\alias{HRSurv}
\description{
Calculation of the integrand of the contant term in the AMISE plugin bandwidth rule implemented in \code{\link{PlugInBand}}.
}

\usage{HRSurv(x, xin, cens, h, kfun) }

\arguments{
 \item{xin}{ A vector of data points}
 \item{x}{ The point at which the estimates should be calculated.}
\item{cens}{ Censoring Indicators.}
\item{h}{ bandwidth to use.}
\item{kfun}{ The kernel function to use.}
}

\details{
Calculates the term
\deqn{  \frac{\lambda_T(x)}{1-F(x)}\,dx }
which is passed then as argument to the function  \code{\link{NP.M.Estimate}} for numerical integtaion. Currrently the fraction is estimated by
\deqn{\frac{\hat \lambda(x;b)}{1-\hat F(x)}}
where \eqn{\hat \lambda(x;b)} is implemented by \code{\link{HazardRateEst}} using bandwidth \code{bw.nrd{xin}}. For \eqn{1-\hat F(x)} the Kaplan-Meier estimate \code{\link{KMest}} is used.
}

\value{
A vector with the value of the fraction.
}

\references{
\href{https://onlinelibrary.wiley.com/doi/full/10.1111/anzs.12224}{Hua, Patil and Bagkavos, An $L_1$ analysis of a kernel-based hazard rate estimator, Australian and New Zealand J. Statist., (60), 43-64, (2018).}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}



\seealso{ \code{\link{PlugInBand}, \link{NP.M.Estimate} } }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated
SampleSize<-100 #amount of data to be generated
ti<- rweibull(SampleSize, .6, 1) # draw a random sample
ui<-rexp(SampleSize, .2)         # censoring sample
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)                  # observed data
cen<-rep.int(1, SampleSize)      # initialize censoring indicators
cen[which(ti>ui)]<-0             # 0's correspond to censored indicators

HRSurv(x, x1, cen, bw.nrd(x1), Biweight)
}

\name{iHazardRateEst}
\title{Kernel Integrated Hazard Rate Estimation}
\alias{iHazardRateEst}
\description{
Implements the integrated kernel hazard rate estimator for right censored data, i.e. a kernel estimate of the cummulative hazard function.
}

\usage{
iHazardRateEst(xin, xout, ikfun, h, ci)
}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
 \item{xout}{A vector of grid points at which the estimates will be calculated. }
  \item{ikfun}{Integrated kernel function to use}
 \item{h}{A scalar, the bandwidth to use in the estimate. }
 \item{ci}{A vector of censoring indicators: 1's indicate uncensored observations, 0's correspond to censored obs.}
}

\details{
The function \code{\link{iHazardRateEst}} implements the cummulative hazard rate estimator \eqn{\hat \Lambda(x; h_1)} given by
\deqn{\hat \Lambda(x; h_1) =   \sum_{i=1}^n \frac{k\left \{(x-X_{(i)})h_1^{-1}\right \}\delta_{(i)}}{n-i+1}}{\hat \Lambda(x; h_1) = \int_{-\infty}^x \lambda(t;h_1)dt}
 where
\deqn{k(x) = \int_{-\infty}^x K(y)\,dy}

Note that  \code{\link{iHazardRateEst}} is used in the implementation of the transformed hazard rate estimate  \code{\link{TransHazRateEst}}.
}

\value{
A vector with the cummulative hazard rate estimates at the designated points xout.
}

\references{
\href{https://projecteuclid.org/download/pdf_1/euclid.aos/1176346265}{Tanner and Wong (1983), The Estimation Of The Hazard Function From Randomly Censored Data By The Kernel Method, Annals of Statistics,  3, pp. 989-993.}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

\seealso{ \code{\link{VarBandHazEst}, \link{TransHazRateEst}, \link{PlugInBand}} }

\examples{
x<-seq(0, 5,length=100) #design points where the estimate will be calculated

SampleSize <- 100
ti<- rweibull(SampleSize, .6, 1)  #draw a random sample from the actual distribution
ui<-rexp(SampleSize, .2)  #draw a random sample from the censoring distribution
cat("\n AMOUNT OF CENSORING: ", length(which(ti>ui))/length(ti)*100, "\n")
x1<-pmin(ti,ui)             #this is the observed sample
cen<-rep.int(1, SampleSize) #censoring indicators
cen[which(ti>ui)]<-0        #censored values correspond to zero
huse<-PlugInBand(x1, x,   cen, Biweight)
arg2<-iHazardRateEst(x1, x, IntEpanechnikov, huse, cen) #Calculate the estimate
}

\name{lambdahat}
\title{Discrete non parametric mle hazard rate estimator}
\alias{lambdahat}

\description{
Implementation of the purely nonparametric discrete hazard rate estimator \code{lambdahat} discussed among others in \href{https://onlinelibrary.wiley.com/doi/abs/10.1002/bimj.201100058}{Patil and Bagkavos (2012)}.  \code{lambdahat} is also used as the nonparametric component in the implementation of \code{\link{SemiparamEst}}.
}

\usage{
 lambdahat(xin, cens, xout)
}

\arguments{
\item{xin}{A vector of data points.  Missing values not allowed.}
\item{cens}{Censoring indicators as a vector of 1s and zeros, 1's indicate uncensored observations, 0's correspond to censored obs.}
\item{xout}{The grid points where the estimates will be calculated.}
}

\details{
The discrete - crude - hazard rate estimator (NPMLE) in \href{https://onlinelibrary.wiley.com/doi/abs/10.1002/bimj.201100058}{Patil and Bagkavos (2012)} is given by
\deqn{\hat \lambda(t_k) =   \frac{n^0_k}{m_k+1} }{\lambda(t_k) =n^0_k * (m_k+1)^{-1}}
}

\value{
Returns a vector with the values of the hazard rate estimates at \eqn{x=xout}.
}

\references{
 \href{https://onlinelibrary.wiley.com/doi/abs/10.1002/bimj.201100058}{Patil and Bagkavos (2012), Semiparametric smoothing of discrete failure time data,  Biometrical Journal, 54, (2012), 5--19.}
}

%\author{
%Dimitrios Bagkavos
%
%R implementation and documentation: Dimitrios Bagkavos <dimitrios.bagkavos@gmail.com>
%}

%\note{
%%  ~~further notes~~
%}

\seealso{
\code{\link{SemiparamEst}
}
}

\examples{
options(echo=FALSE)
xin<-c(7,34,42,63,64, 74, 83, 84, 91, 108, 112,129, 133,133,139,140,140,146,
      149,154,157,160,160,165,173,176,185, 218,225,241, 248,273,277,279,297,
      319,405,417,420,440, 523,523,583, 594, 1101, 1116, 1146, 1226, 1349,
      1412, 1417)
cens<-c(1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,
        0,1,0,1,1,1,1,1,0,1,1,1,0,1)
xin<-xin/30.438    #Adjust the data
storage.mode(xin)<-"integer"  # turn the data to integers
xout<-seq(1,47, by=1)  # define the grid points to evaluate the estimate
arg<-TutzPritscher(xin,cens,xout)   #Discrete kernel estimate
plot(xout, arg, type="l", ylim=c(0, .35), lty=2,  col=6) # plot the estimate
argSM<-lambdahat(xin, cens, xout)  #crude nonparametric estimate
lines(xout, argSM, lty=3, col=5) # plot the crude estimate
}
